/***************************************************************************
**
**  This file is part of GeopsyCore.
**
**  GeopsyCore is free software: you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation, either version 3 of the License, or
**  (at your option) any later version.
**
**  GeopsyCore is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with Foobar.  If not, see <http://www.gnu.org/licenses/>
**
**  See http://www.geopsy.org for more information.
**
**  Created: 2010-07-29
**  Copyright: 2010-2019
**    Marc Wathelet (LGIT, Grenoble, France)
**
***************************************************************************/

#ifndef METADATAFIELDLIST_H
#define METADATAFIELDLIST_H

#include "MetaDataField.h"
#include "GeopsyCoreDLLExport.h"

namespace GeopsyCore {

class GEOPSYCORE_EXPORT MetaDataFieldList : private QList<MetaDataField>
{
public:
  typedef QList<MetaDataField>::iterator iterator;
  iterator begin() {return QList<MetaDataField>::begin();}
  iterator end() {return QList<MetaDataField>::end();}
  typedef QList<MetaDataField>::const_iterator const_iterator;
  const_iterator begin() const {return QList<MetaDataField>::begin();}
  const_iterator end() const {return QList<MetaDataField>::end();}

  void getSettings();
  void setSettings() const;

  void setDefaults();
  void setAll();

  void clear() {QList<MetaDataField>::clear();}
  void add (const MetaDataField& d) {append(d);}
  const MetaDataField& at(int index) const {return QList<MetaDataField>::at(index);}
  int count() const {return QList<MetaDataField>::count();}
};

} // namespace GeopsyCore

#endif // METADATAFIELDLIST_H
